#!/bin/bash
#
# This script is used to detect high load on a server
# and block offending IPs using iptables.
#
# It is intended to be run as systemd service, started by a timer every 5 min.

# Parameters
LOAD_MAX={{ auto_block_load_max }}
LOG_PERIOD="{{ auto_block_log_period }}"
REQUEST_LIMIT={{ auto_block_request_limit }}
BLOCK={{ auto_block_execute }}

# Function to block offending IPs
auto_block_worst_offenders() {
  journalctl -u docker.service --since "$LOG_PERIOD" -g '"remote_addr"' --output cat | \
    jq .remote_addr | \
    sort -n | \
    uniq -c | \
    sort -n | \
  while read -r line; do
    local count
    count=$(echo "$line" | tr -d ' ' | cut -f1 -d\")
    local ip
    ip=$(echo "$line" | tr -d ' ' | cut -f2 -d\")
    if [[ $count -gt $REQUEST_LIMIT ]]; then
      echo "iptables -I DOCKER-USER -s $ip -j DROP"
      if [[ $BLOCK -eq 1 ]]; then
        iptables -I DOCKER-USER -s "$ip" -j DROP
      fi
    fi
  done
}

# Function to check and log high load
check_load() {
  local current_load
  current_load=$(awk '{ print $3;}' < /proc/loadavg)
  if (( $(echo "$current_load > $LOAD_MAX" | bc -l) )); then
    echo "# $(date) - Load is higher than $LOAD_MAX"
    echo "# Current load: $current_load"
    echo "# Suggested iptables rules to block high traffic IPs:"

    auto_block_worst_offenders
  fi
}

# Main script execution
check_load